#ifndef FRAME_CPP__Common__CHECKSUM_HH
#define	FRAME_CPP__Common__CHECKSUM_HH

#include "general/types.hh"

namespace FrameCPP
{
  namespace Common
  {
    class CheckSum
    {
    public:
      enum kind_type {
	NONE = 0,
	CRC = 1
      };

      typedef INT_4U size_type;

      CheckSum( const kind_type Type );

      virtual ~CheckSum( );

      static CheckSum* Create( kind_type Type );

      kind_type GetType( ) const;

      virtual void Reset( );

      virtual void calc( const void* Buffer, size_type NBytes ) = 0;

      //: Things to be do to complete the calculation
      INT_4U value( );

      virtual CheckSum* Clone( ) const = 0;

    protected:
      INT_4U		m_value;

      CheckSum( const CheckSum& Source );
      virtual void finish( ) = 0;

    private:
      kind_type		m_type;
      CheckSum( );
    };

    inline CheckSum::kind_type CheckSum::
    GetType( ) const
    {
      return m_type;
    }

    inline INT_4U CheckSum::
    value( )
    {
      finish( );
      return m_value;
    }

    class CheckSumCRC
      : public CheckSum
    {
    public:
      CheckSumCRC( );
      virtual CheckSumCRC* Clone( ) const;

      virtual void Reset( );

      virtual void calc( const void* Buffer, size_type NBytes );

    protected:
      CheckSumCRC( const CheckSumCRC& Source );
      virtual void finish( );

    private:
      static const INT_4U	m_crctab[ 256 ];

      bool		m_active;
      size_type		m_number_of_bytes;
    };
  } // namespace - Common
} // namespace - FrameCPP

#endif	/* FRAME_CPP__Common__CHECKSUM_HH */
